Subject: Re: [PATCH v8 00/37] mm/virtio: skip redundant zeroing of host-zeroed pages

From: "Michael S. Tsirkin" <[email-masked]>
Date: Wed, 27 May 2026 01:25:22 -0400

On Wed, May 27, 2026 at 11:23:23AM +0800, Miaohe Lin wrote:
> On 2026/5/21 22:09, Michael S. Tsirkin wrote:
> > On Wed, May 20, 2026 at 06:20:13PM -0400, Michael S. Tsirkin wrote:
> >> When a guest reports free pages to the hypervisor via virtio-balloon's
> >> free page reporting, the host typically zeros those pages when reclaiming
> >> their backing memory (e.g., via MADV_DONTNEED on anonymous mappings).
> >> When the guest later reallocates those pages, the kernel zeros them
> >> again, redundantly.
> > 
> > FYI Sashiko reported a couple of issues. Mostly false positives but
> > I tweaked commit log to make it clearer. But also a couple of
> > real issues. So far I have this diff on top:
> > 
> > --->
> > 
> > Changes from v8 to v9 candidate (code only):
> > 
> > 1. mm/mempolicy.c (patch 1: mm: mempolicy: fix interleave index calculation)
> >    Combine vm_pgoff and VMA offset into a single expression before
> >    shifting, fixing carry loss for file-backed VMAs with unaligned
> >    vm_pgoff.
> > 
> > 2. mm/memory-failure.c (patch 2: mm: memory-failure: serialize TestSetPageHWPoison with zone->lock)
> >    Wrap ClearPageHWPoison in retry path with zone->lock too.
> 
> It seems TestClearPageHWPoison and SetPageHWPoison are missing. Should we serialize them with zone->lock too?
> 
> Thanks.
> .

I don't think so.  As far as I could tell, none of these are called on
pages that could be in the buddy. And all the non atomic page flags
games we play are only on pages in the buddy.

-- 
MST